function crm00023000_Relatorio_Controller(ScreenService, Operador_Repository, templateManager, Utilities, wizardEngine, ZHPromise) {

    var self = this;

    /*self.changeHourFilter = function() {
        var widget = templateManager.container.getActiveWidget();
        var stripe = templateManager.container.getWidget('STRIPE');

        if(!stripe.currentRow.HORAS) stripe.currentRow.HORAS = 6;
        else widget.dataSourceFilter[1].value = stripe.currentRow.HORAS;

        widget.reload();
    };*/

    self.iniciaFiltrosWidparcnegocio_caso = function(widget)
    {
        Operador_Repository.retornaOperadorLogado().then(function(operator)
        {
            if(operator[0] === undefined || operator[0] === null)
            {
                ScreenService.showMessage("Erro ao realizar a operação.");
                return;
            }
            Utilities.insertFilter(widget, "P_NRORG", "=", operator[0].NRORG, 0);
            Utilities.insertFilter(widget, "P_CDOPERADOR", "=", operator[0].CDOPERADOR, 1);
        }, function(error)
        {
            ScreenService.showMessage("Erro ao realizar a operação.");
        });
    };

    self.iniciaFiltrosWidsistema_caso = function(widget)
    {
        Operador_Repository.retornaOperadorLogado().then(function(operator)
        {
            if(operator[0] === undefined || operator[0] === null)
            {
                ScreenService.showMessage("Erro ao realizar a operação.");
                return;
            }
            Utilities.insertFilter(widget, "P_NRORG", "=", operator[0].NRORG, 0);
            Utilities.insertFilter(widget, "P_CDOPERADOR", "=", operator[0].CDOPERADOR, 1);
        }, function(error)
        {
            ScreenService.showMessage("Erro ao realizar a operação.");
        });
    };

    self.iniciaFiltrosWidsemretorno = function(widget)
    {
        Operador_Repository.retornaOperadorLogado().then(function(operator)
        {
            if(operator[0] === undefined || operator[0] === null)
            {
                ScreenService.showMessage("Erro ao realizar a operação.");
                return;
            }
            Utilities.insertFilter(widget, "P_CDOPERADOR", "=", operator[0].CDOPERADOR, 1);
            Utilities.insertFilter(widget.getField("CDSISTEMA"), "CDOPERADOR", "=", operator[0].CDOPERADOR, 0);
        }, function(error)
        {
            ScreenService.showMessage("Erro ao realizar a operação.");
        });
    };

    self.iniciaFiltrosWidsegretPadrao = function(widget)
    {
        Operador_Repository.retornaOperadorLogado().then(function(operator)
        {
            if(operator[0] === undefined || operator[0] === null)
            {
                ScreenService.showMessage("Erro ao realizar a operação.");
                return;
            }
            Utilities.insertFilter(widget, "P_CDOPERADOR", "=", operator[0].CDOPERADOR, 2);
            Utilities.insertFilter(widget.getField("CDSISTEMA"), "CDOPERADOR", "=", operator[0].CDOPERADOR, 0);
        }, function(error)
        {
            ScreenService.showMessage("Erro ao realizar a operação.");
        });
    };

    self.iniciaFiltrosWidcasossemconc = function(widget)
    {
        Operador_Repository.retornaOperadorLogado().then(function(operator)
        {
            if(operator[0] === undefined || operator[0] === null)
            {
                ScreenService.showMessage("Erro ao realizar a operação.");
                return;
            }
            Utilities.insertFilter(widget, "P_NRORG", "=", operator[0].NRORG, 1);
            Utilities.insertFilter(widget, "P_CDOPERADOR", "=", operator[0].CDOPERADOR, 2);
            Utilities.insertFilter(widget.getField("CDSISTEMA"), "CDOPERADOR", "=", operator[0].CDOPERADOR, 0);
        }, function(error)
        {
            ScreenService.showMessage("Erro ao realizar a operação.");
        });
    };

    self.filtrarRelatorio = function() {
        var popup = templateManager.container.getActiveWidget();

        var HORAS = (popup.currentRow.HORAS)? popup.currentRow.HORAS : 6;
        var CDOPERADOR = (popup.currentRow.CDOPERADOR)? popup.currentRow.CDOPERADOR : null;
        var CDMOTICONT = (popup.currentRow.CDMOTICONT)? popup.currentRow.CDMOTICONT : null;
        var CDSISTEMA = (popup.currentRow.CDSISTEMA)? popup.currentRow.CDSISTEMA : null;

        var filtro = []; var i = 0;

        filtro[i] = popup.parent.dataSourceFilter[i]; i++;
        filtro[i] = popup.parent.dataSourceFilter[i];
        filtro[i].value = HORAS; i++;
        filtro[i] = popup.parent.dataSourceFilter[i]; i++;
        filtro[i] = popup.parent.dataSourceFilter[i]; i++;

        if(CDOPERADOR) {
            filtro[i] = {
                "name": "CDOPERADOR",
                "operator": "IN",
                "value": CDOPERADOR
            };
            i++;
        }
        if(CDMOTICONT) {
            filtro[i] = {
                "name": "CDMOTICONT",
                "operator": "IN",
                "value": CDMOTICONT
            };
            i++;
        }
        if(CDSISTEMA) {
            filtro[i] = {
                "name": "CDSISTEMA",
                "operator": "IN",
                "value": CDSISTEMA
            };
            i++;
        }

        popup.parent.dataSourceFilter = filtro;
        Utilities.masterDetailClosePopup();
        popup.parent.reload();
    };

    self.openFilter = function() {
        var widget = templateManager.container.getActiveWidget();
    	var filtro = templateManager.container.getWidget('relatoriofilter');

    	if(!filtro.currentRow.HORAS) filtro.currentRow.HORAS = widget.dataSourceFilter[1].value;

    	Utilities.masterDetailOpenPopup(filtro.name);
    };

    self.removeFilters = function() {
        var popup = templateManager.container.getActiveWidget();

        popup.currentRow = {};
        popup.reload();
    };

    self.setColor = function() {
        var widget = templateManager.container.getActiveWidget();

        widget.currentRow.NRCORDESTAQUECASO = widget.currentRow.NRCORDESTAQUECASO.toHexString();
    };

    self.warnCount = function() {
        var widget = templateManager.container.getActiveWidget();

        var mensagem = ((widget.currentRow.PARCEIRO)? widget.currentRow.PARCEIRO : widget.currentRow.SISTEMA)+" tem "+
                        widget.currentRow.CASOS+((widget.currentRow.CASOS > 1)? " casos abertos" : " caso aberto");

        ScreenService.showMessage(mensagem, "INFORMATION", "information");
    };
}

Configuration(function(ContextRegister) {
    ContextRegister.register('crm00023000_Relatorio_Controller', crm00023000_Relatorio_Controller);
});